/**
 * Die Klasse stellt eine Repraesentation des Leser-Schreiber-Territoriums dar.
 *
 * @author Dietrich Boles (Universitaet Oldenburg)
 * @version 1.0 (12.12.2008)
 *
 */
public class LSTerritorium extends Territorium {
    public LSTerritorium() {
        super(3, 20);

        // Mauern platzieren
        for (int i = 0; i < 5; i++) {
            this.add(new Mauer(), i, 2);
        }

        for (int i = 14; i < 20; i++) {
            this.add(new Mauer(), i, 2);
        }

        this.add(new Mauer(), 4, 1);
        this.add(new Mauer(), 14, 1);

        // Koerner platzieren
        for (int i = 5; i < 14; i++) {
            this.add(new Korn(), i, 0);
        }

        this.add(new Korn(), 8, 0);

        // Schwergewichte starten
        int ANZAHL_SCHWERGEWICHTE = 2;

        for (int i = 0; i < ANZAHL_SCHWERGEWICHTE; i++) {
            Hamster ham = new Schwergewicht();
            ham.setPriority(Math.min((i + 1) * 2, Thread.MAX_PRIORITY));
            this.add(ham, this.getAnzahlSpalten() - 1, 1);
        }

        // Leichtgewichte starten
        int ANZAHL_LEICHTGEWICHTE = 3;

        for (int i = 0; i < ANZAHL_LEICHTGEWICHTE; i++) {
            Hamster ham = new Leichtgewicht();
            ham.setPriority(Math.min((i + 1) * 2, Thread.MAX_PRIORITY));
            this.add(ham, 0, 1);
        }
    }
}
